# Section 6. BIND 9 Configuration Reference

BIND 9 configuration is broadly similar to BIND 8.x; however, there are a few new areas of configuration, such as views. BIND 8.x configuration files should work with few alterations in BIND 9, although more complex configurations should be reviewed to check if they can be more efficiently implemented using the new features found in BIND 9.

BIND 4 configuration files can be converted to the new format using the shell script
contrib/named-bootconf/named-bootconf.sh .

### 6.1 Configuration File Elements

Following is a list of elements used throughout the BIND configuration file documentation:

###### acl_name | The name of an address_match_list as defined by the `acl` statement.
###### address_match_list | A list of one or more ip_addr `,` ip_prefix `,` key_id `,` or acl_name elements, as described in Address Match Lists .
###### domain_name | A quoted string which will be used as a DNS name, for example " my.test.domain ".
###### dotted_decimal | One or more integers valued 0 through 255 separated only by dots (`.'), such as `123` , `45.67` or `89.123.45.67` .
###### ip4_addr | An IPv4 address with exactly four elements in dotted_decimal notation.
###### ip6_addr | An IPv6 address, such as `fe80::200:f8ff:fe01:9742` .
###### ip_addr | An ip4_addr or`` ip6_addr .
###### ip_port | An IP port number . number is limited to 0 through 65535, with values below 1024 typically restricted to root-owned processes. In some cases an asterisk (`*') character can be used as a placeholder to select a random high-numbered port.
###### ip_prefix | An IP network specified as an ip_addr , followed by a slash (`/') and then the number of bits in the netmask. For example, `127/8` is the network `127.0.0.0` with netmask `255.0.0.0` and `1.2.3.0/28` is network `1.2.3.0` with netmask `255.255.255.240` .
###### key_id | A domain_name representing the name of a shared key, to be used for transaction security.
###### key_list | A list of one or more key-ids, separated by semicolons and ending with a semicolon.
###### number | A non-negative integer with an entire range limited by the range of a C language signed integer (2,147,483,647 on a machine with 32 bit integers). Its acceptable value might further be limited by the context in which it is used.
###### path_name | A quoted string which will be used as a pathname, such as " zones/master/my.test.domain " .
###### size_spec | A number, the word `unlimited` , or the word `default` . The maximum value of size_spec is that of unsigned long integers on the machine. An unlimited size_spec requests unlimited use, or the maximum available amount. A default size_spec uses the limit that was in force when the server was started. A number can optionally be followed by a scaling factor: `K` or `k` `` for kilobytes, `M` or `m` for megabytes, and `G` or `g` for gigabytes, which scale by 1024, 1024*1024, and 1024*1024*1024 respectively. Integer storage overflow is currently silently ignored during conversion of scaled values, resulting in values less than intended, possibly even negative. Using unlimited is the best way to safely set a really large number.
###### yes_or_no | Either `yes` or `no` . The words `true` and `false` are also accepted, as are the numbers `1` and `0` .

#### 6.1.1 Address Match Lists

##### 6.1.1.1 Syntax

`address_match_list` = address_match_list_element ;
[ address_match_list_element`;` ... ]
`address_match_list_element =` [ ! ] (ip_address [/length] |
`key` key_id | acl_name | { address_match_list } )

##### 6.1.1.2 Definition and Usage

Address match lists are primarily used to determine access control for various server operations. They are also used to define priorities for querying other nameservers and to set the addresses on which `named` will listen for queries. The elements which constitute an address match list can be any of the following:

- an IP address (IPv4 or IPv6)
- an IP prefix (in the `/'-notation)
- a key ID, as defined by the key statement
- the name of an address match list previously defined with the `acl` statement
- a nested address match list enclosed in braces

Elements can be negated with a leading exclamation mark (`!') and the match list names "any," "none," "localhost" and "localnets" are predefined. More information on those names can be found in the description of the acl statement.

The addition of the key clause made the name of this syntactic element something of a misnomer, since security keys can be used to validate access without regard to a host or network address. Nonetheless, the term "address match list" is still used throughout the documentation.

When a given IP address or prefix is compared to an address match list, the list is traversed in order until an element matches. The interpretation of a match depends on whether the list is being used for access control, defining listen-on ports, or as a topology, and whether the element was negated.

When used as an access control list, a non-negated match allows access and a negated match denies access. If there is no match, access is denied. The clauses `allow-query` , `allow-transfer` , `allow-update` and `blackhole` all use address match lists this. Similarly, the listen-on option will cause the server to not accept queries on any of the machine's addresses which do not match the list.

When used with the topology clause, a non-negated match returns a distance based on its position on the list (the closer the match is to the start of the list, the shorter the distance is between it and the server). A negated match will be assigned the maximum distance from the server. If there is no match, the address will get a distance which is further than any non-negated list element, and closer than any negated element.

Because of the first-match aspect of the algorithm, an element that defines a subset of another element in the list should come before the broader element, regardless of whether either is negated. For example, in
`1.2.3/24; ! 1.2.3.13;` the 1.2.3.13 element is completely useless because the algorithm will match any lookup for 1.2.3.13 to the 1.2.3/24 element. Using `! 1.2.3.13; 1.2.3/24` fixes that problem by having 1.2.3.13 blocked by the negation but all other 1.2.3.* hosts fall through.

#### 6.1.2 Comment Syntax

The BIND 9 comment syntax allows for comments to appear anywhere that white space may appear in a BIND configuration file. To appeal to programmers of all kinds, they can be written in C, C++, or shell/perl constructs.

##### 6.1.2.1 Syntax

/* This is a BIND comment as in C */
// This is a BIND comment as in C++
# This is a BIND comment as in common UNIX shells and perl

##### 6.1.2.2 Definition and Usage

Comments may appear anywhere that whitespace may appear in a BIND configuration file.

C-style comments start with the two characters /* (slash, star) and end with */ (star, slash). Because they are completely delimited with these characters, they can be used to comment only a portion of a line or to span multiple lines.

C-style comments cannot be nested. For example, the following is not valid because the entire comment ends with the first */:

/* This is the start of a comment.
This is still part of the comment.
/* This is an incorrect attempt at nesting a comment. */
This is no longer in any comment. */

C++-style comments start with the two characters // (slash, slash) and continue to the end of the physical line. They cannot be continued across multiple physical lines; to have one logical comment span multiple lines, each line must use the // pair.

For example:

// This is the start of a comment. The next line
// is a new comment, even though it is logically
// part of the previous comment.

Shell-style (or perl-style, if you prefer) comments start with the character # (number sign) and continue to the end of the physical line, as in C++ comments.

For example:

# This is the start of a comment. The next line
# is a new comment, even though it is logically
# part of the previous comment.

WARNING: you cannot use the semicolon (`;') character to start a comment such as you would in a zone file. The semicolon indicates the end of a configuration statement.

### 6.2 Configuration File Grammar

A BIND 9 configuration consists of statements and comments. Statements end with a semicolon. Statements and comments are the only elements that can appear without enclosing braces. Many statements contain a block of substatements, which are also terminated with a semicolon.

The following statements are supported:

`acl` | defines a named IP address matching list, for access control and other uses.
`controls` | declares control channels to be used by the `rndc` utility.
`include` | includes a file.
`key` | specifies key information for use in authentication and authorization using TSIG.
`logging` | specifies what the server logs, and where the log messages are sent.
`options` | controls global server configuration options and sets defaults for other statements.
`server` | sets certain configuration options on a per-server basis.
`trusted-keys` | defines trusted DNSSEC keys.
`view` | defines a view.
`zone` | defines a zone.

The `logging` and `options` statements may only occur once per configuration.

#### 6.2.1 `acl` Statement Grammar

    acl acl-name {
        address_match_list
    };

#### 6.2.2 `acl` Statement Definition and Usage

The `acl` statement assigns a symbolic name to an address match list. It gets its name from a primary use of address match lists: Access Control Lists (ACLs).

Note that an address match list's name must be defined with `acl` before it can be used elsewhere; no forward references are allowed.

The following ACLs are built-in:

`any` | Matches all hosts.
`none` | Matches no hosts.
`localhost` | Matches the IP addresses of all interfaces on the system.
`localnets` | Matches any host on a network for which the system has an interface.

#### 6.2.3 `controls` Statement Grammar

    controls {
       [ inet (ip_addr|*) port ip_port allow { address_match_list }
             keys { key-list } ;
       [ inet...;};

#### 6.2.4 `controls` Statement Definition and Usage

The `controls` statement declares control channels to be used by system administrators to affect the operation of the local nameserver. These control channels are used by the `rndc` utility to send commands to and retrieve non-DNS results from a nameserver.

An `inet` control channel is a TCP/IP socket accessible to the Internet, created at the specified `ip_port` on the specified `ip_addr`. If no port is specified, port 953 is used by default. "*" cannot be used for `ip_port`.

The ability to issue commands over the control channel is restricted by the `allow` and `keys` clauses. Connections to the control channel are permitted based on the address permissions in `address_match_list`. `key_id` members of the `address_match_list` are ignored, and instead are interpreted independently based the `key_list`. Each `key_id` in the `key_list` is allowed to be used to authenticate commands and responses given over the control channel by digitally signing each message between the server and a command client (see rndc in Section 3.4.1.2). All commands to the control channel must be signed by one of its specified keys to be honored.

For the initial release of BIND 9.0.0, only one command is possible over the command channel, the command to reload the server. We will expand command set in future releases.

The UNIX control channel type of BIND 8 is not supported in BIND 9.0.0, and is not expected to be added in future releases. If it is present in the controls statement from a BIND 8 configuration file, a non-fatal warning will be logged.

#### 6.2.5 `include` Statement Grammar

`include` filename ;

#### 6.2.6 `include` Statement Definition and Usage

The `include` statement inserts the specified file at the point that the `include` statement is encountered. The `include` statement facilitates the administration of configuration files by permitting the reading or writing of some things but not others. For example, the statement could include private keys that are readable only by a nameserver.

#### 6.2.7 `key` Statement Grammar

`key` key_id`` {
`algorithm` string;
`secret` string;
};

#### 6.2.8 `key` Statement Definition and Usage

The `key` statement defines a shared secret key for use with TSIG. See TSIG .

The key_id , also known as the key name, is a domain name uniquely identifying the key. It can be used in a "server" statement to cause requests sent to that server to be signed with this key, or in address match lists to verify that incoming requests have been signed with a key matching this name, algorithm, and secret.

The algorithm_id is a string that specifies a security/authentication algorithm. The only algorithm currently supported with TSIG authentication is `hmac-md5` . The secret_string is the secret to be used by the algorithm, and is treated as a base-64 encoded string.

#### 6.2.9 `logging` Statement Grammar

    logging {
       [ channel channel_name {
         ( file path name
             [ versions ( number | unlimited ) ]
             [ size size spec ]
           | syslog ( syslog_facility
           | null );
         [ severity (critical | error | warning | notice |
                     info | debug [ level ] | dynamic ; ]
         [ print-category yes or no;
         [ print-severity yes or no; ]
         [ print-time yes or no; ]
       }; ]
       [ category category_name {
         channel_name ; [ channel_name ; ... ]
       }; ]
        ...
    };

#### 6.2.10 `logging` Statement Definition and Usage

The `logging` statement configures a wide variety of logging options for the nameserver. Its `channel` phrase associates output methods, format options and severity levels with a name that can then be used with the `category` phrase to select how various classes of messages are logged.

Only one `logging` statement is used to define as many channels and categories as are wanted. If there is no `logging` statement, the logging configuration will be:

    logging {
         category "default" { "default_syslog"; "default_debug"; };
      };

In BIND 9, the logging configuration is only established when the entire configuration file has been parsed. In BIND 8, it was established as soon as the `logging` statement was parsed. When the server is starting up, all logging messages regarding syntax errors in the configuration file go to the default channels, or to standard error if the "`-g` " option was specified.

##### 6.2.10.1 The `channel` Phrase

All log output goes to one or more channels ; you can make as many of them as you want.

Every channel definition must include a clause that says whether messages selected for the channel go to a file, to a particular syslog facility, or are discarded. It can optionally also limit the message severity level that will be accepted by the channel (the default is `info` ), and whether to include a `named` -generated time stamp, the category name and/or severity level (the default is not to include any).

The word `null` as the destination option for the channel will cause all messages sent to it to be discarded; in that case, other options for the channel are meaningless.

The `file` clause can include limitations both on how large the file is allowed to become, and how many versions of the file will be saved each time the file is opened.

The `size` option for files is simply a hard ceiling on log growth. If the file ever exceeds the size, then `named` will not write anything more to it until the file is reopened; exceeding the size does not automatically trigger a reopen. The default behavior is not to limit the size of the file.

If you use the `version` log file option, then `named` will retain that many backup versions of the file by renaming them when opening. For example, if you choose to keep 3 old versions of the file lamers.log then just before it is opened lamers.log.1 is renamed to lamers.log.2 , lamers.log.0 is renamed to lamers.log.1 , and lamers.log is renamed to lamers.log.0 . No rolled versions are kept by default; any existing log file is simply appended. The `unlimited` keyword is synonymous with `99` in current BIND releases.

Example usage of the size and versions options:

        channel "an_example_channel" {
            file "example.log" versions 3 size 20m;
            print-time yes;
            print-category yes;
        };

The argument for the `syslog` clause is a syslog facility as described in the `syslog` man page. How `syslog` will handle messages sent to this facility is described in the `syslog.conf` man page. If you have a system which uses a very old version of `syslog` that only uses two arguments to the `openlog()` function, then this clause is silently ignored.

The `severity` clause works like `syslog` 's "priorities," except that they can also be used if you are writing straight to a file rather than using `syslog` . Messages which are not at least of the severity level given will not be selected for the channel; messages of higher severity levels will be accepted.

If you are using `syslog` , then the `syslog.conf` priorities will also determine what eventually passes through. For example, defining a channel facility and severity as `daemon` and `debug` but only logging `daemon.warning` via `syslog.conf` will cause messages of severity `info` and `notice` to be dropped. If the situation were reversed, with `named` writing messages of only `warning` or higher, then `syslogd` would print all messages it received from the channel.

The server can supply extensive debugging information when it is in debugging mode. If the server's global debug level is greater than zero, then debugging mode will be active. The global debug level is set either by starting the `named` server with the "`-d` " flag followed by a positive integer, or by running `rndc trace` ( the latter method is not yet implemented ). The global debug level can be set to zero, and debugging mode turned off, by running `ndc notrace` . All debugging messages in the server have a debug level, and higher debug levels give more detailed output. Channels that specify a specific debug severity, for example:

      channel "specific_debug_level" {
          file "foo";
          severity debug 3;
      };

will get debugging output of level 3 or less any time the server is in debugging mode, regardless of the global debugging level. Channels with `dynamic` severity use the server's global level to determine what messages to print.

If `print-time` has been turned on, then the date and time will be logged. `print-time` may be specified for a `syslog` channel, but is usually pointless since `syslog` also prints the date and time. If `print-category` is requested, then the category of the message will be logged as well. Finally, if `print-severity` is on, then the severity level of the message will be logged. The `print-` options may be used in any combination, and will always be printed in the following order: time, category, severity. Here is an example where all three `print-` options are on:

###### `28-Feb-2000 15:05:32.863 general: notice: running`

There are four predefined channels that are used for `named` 's default logging as follows. How they are used is described in the category Phrase .

        channel "default_syslog" {
            syslog daemon;				// end to syslog's daemon
    						// facility
            severity info;				// only send priority info
    						// and higher
        };
        channel "default_debug" {
            file "named.run";			// write to named.run in
    						// the working directory
    						// Note: stderr is used instead
    						// of "named.run"
    						// if the server is started
    						// with the '-f' option.
            severity dynamic			// log at the server's
    						// current debug level
        };
        channel "default_stderr" {			// writes to stderr
            file "<stderr>";			// this is illustrative only;
    						// there's currently no way of
    						// specifying an internal file
    						// descriptor in the
    						// configuration language.
            severity info;				// only send priority info
    						// and higher
        };
        channel "null" {
           null;					// toss anything sent to
    						// this channel
        };

The `default_debug` channel normally writes to a file named.run in the server's working directory. For security reasons, when the "`-u` " command line option is used, the named.run file is created only after `named` has changed to the new UID, and any debug output generated while `named` is starting up and still running as root is discarded. If you need to capture this output, you must run the server with the "`-g` " option and redirect standard error to a file.

Once a channel is defined, it cannot be redefined. Thus you cannot alter the built-in channels directly, but you can modify the default logging by pointing categories at channels you have defined.

##### 6.2.10.2 The `category` Phrase

There are many categories, so you can send the logs you want to see wherever you want, without seeing logs you don't want. If you don't specify a list of channels for a category, then log messages in that category will be sent to the `default` category instead. If you don't specify a default category, the following "default default" is used:

    category "default" { "default_syslog"; "default_debug"; };

As an example, let's say you want to log security events to a file, but you also want keep the default logging behavior. You'd specify the following:

    channel "my_security_channel" {
        file "my_security_file";
        severity info;
    };
    category "security" {
        "my_security_channel";
        "default_syslog";
        "default_debug";
    };

To discard all messages in a category, specify the `null` channel:

    category "xfer-out" { "null"; };
    category "notify" { "null"; };

Following are the available categories and brief descriptions of the types of log information they contain . More categories may be added in future BIND releases.

`default` | The default category defines the logging options for those categories where no specific configuration has been defined.
`general` | The catch-all. Many things still aren't classified into categories, and they all end up here.
`database` | Messages relating to the databases used internally by the name server to store zone and cache data.
`security` | Approval and denial of requests.
`config` | Configuration file parsing and processing.
`resolver` | DNS resolution, such as the recursive lookups performed on behalf of clients by a caching name server.
`xfer-in` | Zone transfers the server is receiving.
`xfer-out` | Zone transfers the server is sending.
`notify` | The NOTIFY protocol.
`client` | Processing of client requests.
`network` | Network operations.
`update` | Dynamic updates.

#### 6.2.11 `options` Statement Grammar

This is the grammar of the `option` statement in the named.conf file:

    options {

        [ version version_string; ]
        [ directory path_name; ]
        [ named-xfer path_name; ]
        [ tkey-domain domainname; ]
        [ tkey-dhkey key_name key_tag; ]
        [ dump-file path_name; ]
        [ memstatistics-file path_name; ]
        [ pid-file path_name; ]
        [ statistics-file path_name; ]
        [ auth-nxdomain yes_or_no; ]
        [ deallocate-on-exit yes_or_no; ]
        [ dialup yes_or_no; ]
        [ fake-iquery yes_or_no; ]
        [ fetch-glue yes_or_no; ]
        [ has-old-clients yes_or_no; ]
        [ host-statistics yes_or_no; ]
        [ multiple-cnames yes_or_no; ]
        [ notify yes_or_no; ]
        [ recursion yes_or_no; ]
        [ rfc2308-type1 yes_or_no; ]
        [ use-id-pool yes_or_no; ]
        [ maintain-ixfr-base yes_or_no; ]
        [ forward ( only | first ); ]
        [ forwarders { [ in_addr ; [ in_addr ; ... ] ] }; ]
        [ check-names ( master | slave | response )( warn | fail | ignore ); ]
        [ allow-query { address_match_list }; ]
        [ allow-transfer { address_match_list }; ]
        [ allow-recursion { address_match_list }; ]
        [ blackhole { address_match_list  };  ]
        [ listen-on [ port ip_port ] { address_match_list }; ]
        [ query-source [ address ( ip_addr | * ) ] [ port ( ip_port | * ) ]; ]
        [ max-transfer-time-in number; ]
        [ max-transfer-time-out number; ]
        [ max-transfer-idle-in number; ]
        [ max-transfer-idle-out number; ]
        [ tcp-clients number; ]
        [ recursive-clients number; ]
        [ serial-queries number; ]
        [ transfer-format ( one-answer | many-answers ); ]
        [ transfers-in  number; ]
        [ transfers-out number; ]
        [ transfers-per-ns number; ]
        [ transfer-source ip4_addr; ]
        [ transfer-source-v6 ip6_addr; ]
        [ also-notify { ip_addr; [ ip_addr; ... ] }; ]
        [ max-ixfr-log-size number; ]    [ coresize size_spec ; ]    [ datasize size_spec ; ]    [ files size_spec ; ]    [ stacksize size_spec ; ]    [ cleaning-interval number; ]    [ heartbeat-interval number; ]    [ interface-interval number; ]    [ statistics-interval number; ]
        [ topology { address_match_list }; ]
        [ sortlist { address_match_list }; ]
        [ rrset-order { order_spec ; [ order_spec ; ... ] ] };    [ lame-ttl number; ]    [ max-ncache-ttl number; ]
        [ max-cache-ttl number; ]
        [ sig-validity-interval number ; ]
        [ min-roots number; ]
        [ use-ixfr yes_or_no ; ]
        [ treat-cr-as-space yes_or_no ; ]
    };

#### 6.2.12 `options` Statement Definition and Usage

The `options` statement sets up global options to be used by BIND. This statement may appear only once in a configuration file. If more than one occurrence is found, the first occurrence determines the actual options used, and a warning will be generated. If there is no `options` statement, an options block with each option set to its default will be used.

`version` | The version the server should report via a query of name version.bind in class `chaos` . The default is the real version number of this server.
`directory` | The working directory of the server. Any non-absolute pathnames in the configuration file will be taken as relative to this directory. The default location for most server output files (e.g. named.run ) is this directory. If a directory is not specified, the working directory defaults to ` . ', the directory from which the server was started. The directory specified should be an absolute path.
`named-xfer` | This option is obsolete. It was used in BIND 8 to specify the pathname to the `named-xfer` program. In BIND 9, no separate `named-xfer` program is needed; its functionality is built into the name server.
`tkey-domain` | The domain appended to the names of all shared keys generated with `TKEY` . When a client requests a `TKEY` exchange, it may or may not specify the desired name for the key. If present, the name of the shared key will be " client specified part " + " tkey-domain ". Otherwise, the name of the shared key will be " random hex digits " + " tkey-domain ". In most cases, the `domainname` should be the server's domain name.
`tkey-dhkey` | The Diffie-Hellman key used by the server to generate shared keys with clients using the Diffie-Hellman mode of `TKEY` . The server must be able to load the public and private keys from files in the working directory. In most cases, the keyname should be the server's host name.
`dump-file` | The pathname of the file the server dumps the database to when it receives `SIGINT` signal (`ndc dumpdb` ). If not specified, the default is named_dump.db . Not yet implemented in BIND 9.
`memstatistics-file` | The pathname of the file the server writes memory usage statistics to on exit. If not specified, the default is named.memstats . Not yet implemented in BIND 9.
`pid-file` | The pathname of the file the server writes its process ID in. If not specified, the default is operating system dependent, but is usually /var/run/named.pid or /etc/named.pid . The pid-file is used by programs that want to send signals to the running nameserver.
`statistics-file` | The pathname of the file the server appends statistics to. If not specified, the default is named.stats . Not yet implemented in BIND 9 .

##### 6.2.12.1 Boolean Options

`auth-nxdomain` | If `yes` , then the `AA` bit is always set on NXDOMAIN responses, even if the server is not actually authoritative. The default is `no` ; this is a change from BIND 8. If you are using very old DNS software, you may need to set it to `yes` .
`deallocate-on-exit` | This option was used in BIND 8 to enable checking for memory leaks on exit. BIND 9 ignores the option and always performs the checks.
`dialup` | If `yes` , then the server treats all zones as if they are doing zone transfers across a dial on demand dialup link, which can be brought up by traffic originating from this server. This has different effects according to zone type and concentrates the zone maintenance so that it all happens in a short interval, once every `heartbeat-interval` and hopefully during the one call. It also suppresses some of the normal zone maintenance traffic. The default is `no` . The `dialup` option may also be specified in the `zone` statement, in which case it overrides the `options dialup` statement. If the zone is a master then the server will send out a NOTIFY request to all the slaves. This will trigger the zone serial number check in the slave (providing it supports NOTIFY) allowing the slave to verify the zone while the connection is active. If the zone is a slave or stub then the server will suppress the regular "zone up to date" queries and only perform them when the `heartbeat-interval` expires. Not yet implemented in BIND 9.
`fake-iquery` | In BIND 8, this option was used to enable simulating the obsolete DNS query type IQUERY. BIND 9 never does IQUERY simulation.
`fetch-glue` | (Information present outside of the authoritative nodes in the zone is called glue information). If `yes` (the default), the server will fetch glue resource records it doesn't have when constructing the additional data section of a response. `fetch-glue` `no` `` can be used in conjunction with `recursion` `no` `` to prevent the server's cache from growing or becoming corrupted (at the cost of requiring more work from the client). Not yet implemented in BIND 9.
`has-old-clients` | This option was incorrectly implemented in BIND 8, and is ignored by BIND 9. To achieve the intended effect of `has-old-clients` `yes` , specify the two separate options `auth-nxdomain` `yes` and `rfc2308-type1` `no` instead.
`host-statistics` | If `yes` , then statistics are kept for every host that the nameserver interacts with. The default is `no` . Note: turning on `host-statistics` can consume huge amounts of memory. Not yet implemented in BIND 9.
`maintain-ixfr-base` | This option is obsolete . It was used in BIND 8 to determine whether a transaction log was kept for Incremental Zone Transfer. BIND 9 maintains a transaction log whenever possible. If you need to disable outgoing incremental zone transfers, use `provide-ixfr` `no` .
`multiple-cnames` | This option was used in BIND 8 to allow a domain name to allow multiple CNAME records in violation of the DNS standards. BIND 9 currently does not check for multiple CNAMEs in zone data loaded from master files, but such checks may be introduced in a later release. BIND 9 always strictly enforces the CNAME rules in dynamic updates.
`notify` | If `yes` (the default), DNS NOTIFY messages are sent when a zone the server is authoritative for changes. See Notify , for more information. The `notify` option may also be specified in the `zone` statement, in which case it overrides the `options notify` statement. It would only be necessary to turn off this option if it caused slaves to crash .
`recursion` | If `yes` , and a DNS query requests recursion, then the server will attempt to do all the work required to answer the query. If recursion is not on, the server will return a referral to the client if it doesn't know the answer. The default is `yes` . See also `fetch-glue` above.
`rfc2308-type1` | Setting this to `yes` will cause the server to send NS records along with the SOA record for negative answers. The default is `no` . Not yet implemented in BIND 9 .
`use-id-pool` | This option is obsolete . BIND 9 always allocates query IDs from a pool.
`treat-cr-as-space` | This option was used in BIND 8 to make the server treat "`\r` " characters the same way as `<space>` " " or "`\t` ", to facilitate loading of zone files on a UNIX system that were generated on an NT or DOS machine. In BIND 9, both UNIX "`\n` " and NT/DOS "`\r\n` " newlines are always accepted, and the option is ignored.

##### 6.2.12.2 Forwarding

The forwarding facility can be used to create a large site-wide cache on a few servers, reducing traffic over links to external nameservers. It can also be used to allow queries by servers that do not have direct access to the Internet, but wish to look up exterior names anyway. Forwarding occurs only on those queries for which the server is not authoritative and does not have the answer in its cache.

`forward` | This option is only meaningful if the forwarders list is not empty. A value of first , the default, causes the server to query the forwarders first, and if that doesn't answer the question the server will then look for the answer itself. If only is specified, the server will only query the forwarders.
`forwarders` | Specifies the IP addresses to be used for forwarding. The default is the empty list (no forwarding).

Forwarding can also be configured on a per-domain basis, allowing for the global forwarding options to be overridden in a variety of ways. You can set particular domains to use different forwarders, or have a different `forward only/first` behavior, or not forward at all. See zone Statement Grammar for more information.

##### 6.2.12.3 Name Checking

The server can check domain names based upon their expected client contexts. For example, a domain name used as a hostname can be checked for compliance with the RFCs defining valid hostnames.

Three checking methods are available:

`ignore` | No checking is done.
`warn` | Names are checked against their expected client contexts. Invalid names are logged, but processing continues normally.
`fail` | Names are checked against their expected client contexts. Invalid names are logged, and the offending data is rejected.

The server can check names in three areas: master zone files, slave zone files, and in responses to queries the server has initiated. If `check-names response fail` has been specified, and answering the client's question would require sending an invalid name to the client, the server will send a REFUSED response code to the client.

The defaults are:

        check-names master fail;
        check-names slave warn;
        check-names response ignore;

`check-names` may also be specified in the `zone` statement, in which case it overrides the `options check-names` statement. When used in a `zone` statement, the area is not specified because it can be deduced from the zone type.

###### Name checking is not yet implemented in BIND 9.

##### 6.2.12.4 Access Control

Access to the server can be restricted based on the IP address of the requesting system. See Address Match Lists for details on how to specify IP address lists.

`allow-query` | Specifies which hosts are allowed to ask ordinary questions. `allow-query` may also be specified in the `zone` statement, in which case it overrides the `options allow-query` statement. If not specified, the default is to allow queries from all hosts.
`allow-recursion` | Specifies which hosts are allowed to make recursive queries through this server. If not specified, the default is to allow recursive queries from all hosts.
`allow-transfer` | Specifies which hosts are allowed to receive zone transfers from the server. `allow-transfer` may also be specified in the `zone` statement, in which case it overrides the `options allow-transfer` statement. If not specified, the default is to allow transfers from all hosts.
`blackhole` | Specifies a list of addresses that the server will not accept queries from or use to resolve a query. Queries from these addresses will not be responded to. The default is `none` . Not yet implemented in BIND 9.

##### 6.2.12.5 Interfaces

The interfaces and ports that the server will answer queries from may be specified using the `listen-on` option. `listen-on` takes an optional port, and an address_match_list . The server will listen on all interfaces allowed by the address match list. If a port is not specified, port 53 will be used.

Multiple `listen-on` statements are allowed. For example,

    listen-on { 5.6.7.8; };
    listen-on port 1234 { !1.2.3.4; 1.2/16; };

will enable the nameserver on port 53 for the IP address 5.6.7.8, and on port 1234 of an address on the machine in net 1.2 that is not 1.2.3.4.

If no `listen-on` is specified, the server will listen on port 53 on all interfaces.

The `listen-on-v6` option is used to specify the ports on which the server will listen for incoming queries sent using IPv6.

The server does not bind a separate socket to each IPv6 interface address as it does for IPv4. Instead, it always listens on the IPv6 wildcard address. Therefore, the only values allowed for the address_match_list argument to the `listen-on-v6` statement are " { any; } " and " { none; } ".

Multiple `listen-on-v6` options can be used to listen on multiple ports:

    listen-on-v6 port 53 { any; };
    listen-on-v6 port 1234 { any; };

To make the server not listen on any IPv6 address, use

    listen-on-v6 { none; };

If no `listen-on-v6` statement is specified, the server will listen on port 53 on the IPv6 wildcard address.

##### 6.2.12.6 Query Address

If the server doesn't know the answer to a question, it will query other nameservers. `query-source` specifies the address and port used for such queries. For queries sent over IPv6, there is a separate `query-source-v6` option. If `address` is `*` or is omitted, a wildcard IP address (`INADDR_ANY` ) will be used. If `port` is `*` or is omitted, a random unprivileged port will be used. The defaults are

    query-source address * port *;
    query-source-v6 address * port *

Note: `query-source` currently applies only to UDP queries; TCP queries always use a wildcard IP address and a random unprivileged port.

##### 6.2.12.7 Zone Transfers

BIND has mechanisms in place to facilitate zone transfers and set limits on the amount of load that transfers place on the system. The following options apply to zone transfers.

`also-notify` | Defines a global list of IP addresses that are also sent NOTIFY messages whenever a fresh copy of the zone is loaded. This helps to ensure that copies of the zones will quickly converge on stealth servers. If an `also-notify` list is given in a `zone` statement, it will override the `options also-notify` statement. When a `zone notify` statement is set to `no` , the IP addresses in the global `also-notify` list will not be sent NOTIFY messages for that zone. The default is the empty list (no global notification list).
`max-transfer-time-in` | Inbound zone transfers running longer than this many minutes will be terminated. The default is 120 minutes (2 hours).
`max-transfer-idle-in` | Inbound zone transfers making no progress in this many minutes will be terminated. The default is 60 minutes (1 hour).
`max-transfer-time-out` | Outbound zone transfers running longer than this many minutes will be terminated. The default is 120 minutes (2 hours).
`max-transfer-idle-out` | Outbound zone transfers making no progress in this many minutes will be terminated. The default is 60 minutes (1 hour).
`serial-queries` | Slave servers will periodically query master servers to find out if zone serial numbers have changed. Each such query uses a minute amount of the slave server's network bandwidth, but more importantly each query uses a small amount of memory in the slave server while waiting for the master server to respond. The `serial-queries` option sets the maximum number of concurrent serial-number queries allowed to be outstanding at any given time. The default is 4. Note: If a server loads a large (tens or hundreds of thousands) number of slave zones, then this limit should be raised to the high hundreds or low thousands, otherwise the slave server may never actually become aware of zone changes in the master servers. Beware, though, that setting this limit arbitrarily high can spend a considerable amount of your slave server's network, CPU, and memory resources. As with all tunable limits, this one should be changed gently and monitored for its effects. Not yet implemented in BIND 9.
`transfer-format` | The server supports two zone transfer methods. `one-answer` uses one DNS message per resource record transferred. `many-answers` packs as many resource records as possible into a message. `many-answers` is more efficient, but is only known to be understood by BIND 9, BIND 8.x and patched versions of BIND 4.9.5. The default is `many-answers` . `transfer-format` may be overridden on a per-server basis by using the `server` statement.
`transfers-in` | The maximum number of inbound zone transfers that can be running concurrently. The default value is 10 . Increasing `transfers-in` may speed up the convergence of slave zones, but it also may increase the load on the local system.
`transfers-out` | The maximum number of outbound zone transfers that can be running concurrently. Zone transfer requests in excess of the limit will be refused. The default value is 10 .
`transfers-per-ns` | The maximum number of inbound zone transfers that can be concurrently transferring from a given remote nameserver. The default value is 2 . Increasing `transfers-per-ns` may speed up the convergence of slave zones, but it also may increase the load on the remote nameserver. `transfers-per-ns` may be overridden on a per-server basis by using the `transfers` phrase of the `server` statement.
`transfer-source` | `transfer-source` determines which local address will be bound to IPv4 TCP connections used to fetch zones transferred inbound by the server. If not set, it defaults to a system controlled value which will usually be the address of the interface "closest to" the remote end. This address must appear in the remote end's `allow-transfer` option for the zone being transferred, if one is specified. This statement sets the `transfer-source` for all zones, but can be overridden on a per-zone basis by including a `transfer-source` statement within the `zone` block in the configuration file.
`transfer-source-v6` | The same as `transfer-source` , except zone transfers are performed using IPv6.

##### 6.2.12.8 Resource Limits

The server's usage of many system resources can be limited. Some operating systems don't support some of the limits. On such systems, a warning will be issued if the unsupported limit is used. Some operating systems don't support limiting resources.

Scaled values are allowed when specifying resource limits. For example, `1G` can be used instead of `1073741824` to specify a limit of one gigabyte. `unlimited` requests unlimited use, or the maximum available amount. `default` uses the limit that was in force when the server was started. See the description of `size_spec` in Configuration File Elements for more details.

`coresize` | The maximum size of a core dump. The default is default . Not yet implemented in BIND 9.
`datasize` | The maximum amount of data memory the server may use. The default is default . Not yet implemented in BIND 9.
`files` | The maximum number of files the server may have open concurrently. The default is unlimited . Note: on some operating systems the server cannot set an unlimited value and cannot determine the maximum number of open files the kernel can support. On such systems, choosing unlimited will cause the server to use the larger of the `rlim_max` for `RLIMIT_NOFILE` and the value returned by `sysconf(_SC_OPEN_MAX)` . If the actual kernel limit is larger than this value, use `limit files` to specify the limit explicitly. Not yet implemented in BIND 9.
`max-ixfr-log-size` | The `max-ixfr-log-size` will be used in a future release of the server to limit the size of the transaction log kept for Incremental Zone Transfer. Not yet implemented in BIND 9.
`recursive-clients` | The maximum number of simultaneous recursive lookups the server will perform on behalf of clients. The default is 1000 .
`stacksize` | The maximum amount of stack memory the server may use. The default is default . Not yet implemented in BIND 9.
`tcp-clients` | The maximum number of simultaneous client TCP connections that the server will accept. The default is 100 .

Resource limits are not yet implemented in BIND 9.

##### 6.2.12.9 Periodic Task Intervals

`cleaning-interval` | The server will remove expired resource records from the cache every `cleaning-interval` minutes. The default is 60 minutes. If set to 0 , no periodic cleaning will occur.
`heartbeat-interval` | The server will perform zone maintenance tasks for all zones marked `dialup yes` whenever this interval expires. The default is 60 minutes. Reasonable values are up to 1 day (1440 minutes). If set to 0 , no zone maintenance for these zones will occur. Not yet implemented in BIND 9.
`interface-interval` | The server will scan the network interface list every `interface-interval` minutes. The default is 60 minutes. If set to 0 , interface scanning will only occur when the configuration file is loaded. After the scan, listeners will be started on any new interfaces (provided they are allowed by the `listen-on` configuration). Listeners on interfaces that have gone away will be cleaned up.
`statistics-interval` | Nameserver statistics will be logged every `statistics-interval` minutes. The default is 60 . If set to 0 , no statistics will be logged. Not yet implemented in BIND 9.

##### 6.2.12.10 Topology

All other things being equal, when the server chooses a nameserver to query from a list of nameservers, it prefers the one that is topologically closest to itself. The `topology` statement takes an `address_match_list` and interprets it in a special way. Each top-level list element is assigned a distance. Non-negated elements get a distance based on their position in the list, where the closer the match is to the start of the list, the shorter the distance is between it and the server. A negated match will be assigned the maximum distance from the server. If there is no match, the address will get a distance which is further than any non-negated list element, and closer than any negated element. For example,

        topology {
        10/8;
        !1.2.3/24;
        { 1.2/16; 3/8; };
        };

will prefer servers on network 10 the most, followed by hosts on network 1.2.0.0 (netmask 255.255.0.0) and network 3, with the exception of hosts on network 1.2.3 (netmask 255.255.255.0), which is preferred least of all.

The default topology is

        topology { localhost; localnets; };

The `topology` option is not yet implemented in BIND 9.

##### 6.2.12.11 The `sortlist` Statement

Resource Records (RRs) are the data associated with the names in a domain name space. The data is maintained in the form of sets of RRs. The order of RRs in a set is, by default, not significant. Therefore, to control the sorting of records in a set of resource records, or RRset , you must use the `sortlist` statement.

RRs are explained more fully in See Types of Resource Records and When to Use Them . Specifications for RRs are documented in RFC 1035.

When returning multiple RRs the nameserver will normally return them in Round Robin order, that is, after each request the first RR is put at the end of the list. The client resolver code should rearrange the RRs as appropriate, that is, using any addresses on the local net in preference to other addresses. However, not all resolvers can do this or are correctly configured. When a client is using a local server the sorting can be performed in the server, based on the client's address. This only requires configuring the nameservers, not all the clients.

The `sortlist` statement (see below) takes an `address_match_list` and interprets it even more specifically than the `topology` statement does (see Topology ). Each top level statement in the `sortlist` must itself be an explicit `address_match_list` with one or two elements. The first element (which may be an IP address, an IP prefix, an ACL name or a nested `address_match_list` ) of each top level list is checked against the source address of the query until a match is found.

Once the source address of the query has been matched, if the top level statement contains only one element, the actual primitive element that matched the source address is used to select the address in the response to move to the beginning of the response. If the statement is a list of two elements, then the second element is treated the same as the `address_match_list` in a `topology` statement. Each top level element is assigned a distance and the address in the response with the minimum distance is moved to the beginning of the response.

In the following example, any queries received from any of the addresses of the host itself will get responses preferring addresses on any of the locally connected networks. Next most preferred are addresses on the 192.168.1/24 network, and after that either the 192.168.2/24 or
192.168.3/24 network with no preference shown between these two networks. Queries received from a host on the 192.168.1/24 network will prefer other addresses on that network to the 192.168.2/24 and
192.168.3/24 networks. Queries received from a host on the 192.168.4/24 or the 192.168.5/24 network will only prefer other addresses on their directly connected networks.

    sortlist {
        { localhost;					// IF   the local host
            { localnets;					// THEN first fit on the
                192.168.1/24;				//   following nets
                { 192,168.2/24; 192.168.3/24; }; }; };
        { 192.168.1/24;					// IF   on class C 192.168.1
            { 192.168.1/24;					// THEN use .1, or .2 or .3
                { 192.168.2/24; 192.168.3/24; }; }; };
        { 192.168.2/24;					// IF   on class C 192.168.2
            { 192.168.2/24;					// THEN use .2, or .1 or .3
                { 192.168.1/24; 192.168.3/24; }; }; };
        { 192.168.3/24;					// IF   on class C 192.168.3
            { 192.168.3/24;					// THEN use .3, or .1 or .2
                { 192.168.1/24; 192.168.2/24; }; }; };
        { { 192.168.4/24; 192.168.5/24; };
    							// if .4 or .5, prefer that net
        };
    };

The following example will give reasonable behavior for the local host and hosts on directly connected networks. It is similar to the behavior of the address sort in BIND 8.x. Responses sent to queries from the local host will favor any of the directly connected networks. Responses sent to queries from any other hosts on a directly connected network will prefer addresses on that same network. Responses to other queries will not be sorted.

    sortlist {
               { localhost; localnets; };
               { localnets; };
    };

The `sortlist` option is not yet implemented in BIND 9.

##### 6.2.12.12 RRset Ordering

When multiple records are returned in an answer it may be useful to configure the order of the records placed into the response. For example, the records for a zone might be configured always to be returned in the order they are defined in the zone file. Or perhaps a random shuffle of the records as they are returned is wanted. The `rrset-order` statement permits configuration of the ordering made of the records in a multiple record response. The default, if no ordering is defined, is a cyclic ordering (round robin).

An `order_spec` is defined as follows:

    [ class class_name  ][ type type_name ][ name "domain_name"]
         order ordering

If no class is specified, the default is `ANY` . If no type is specified, the default is `ANY` . If no name is specified, the default is "`*` ".

The legal values for `ordering` are:

`fixed` | Records are returned in the order they are defined in the zone file.
`random` | Records are returned in some random order.
`cyclic` | Records are returned in a round-robin order.

For example:

        rrset-order {
            class IN type A name "host.example.com" order random;
            order cyclic;
        };

will cause any responses for type A records in class IN that have " host.example.com " as a suffix, to always be returned in random order. All other records are returned in cyclic order.

If multiple `rrset-order` statements appear, they are not combined--the last one applies.

If no `rrset-order` statement is specified, then a default one of:

        rrset-order { class ANY type ANY name "*"; order cyclic ;
        };

is used.

The `rrset-order` statement is not yet implemented in BIND 9.

##### 6.2.12.13 Tuning

`lame-ttl` | Sets the number of seconds to cache a lame server indication. 0 disables caching. (This is NOT recommended.) Default is 600 (10 minutes). Maximum value is 1800 (30 minutes). Not yet implemented in BIND 9.
`max-ncache-ttl` | To reduce network traffic and increase performance the server stores negative answers. `max-ncache-ttl` is used to set a maximum retention time for these answers in the server in seconds. The default `max-ncache-ttl` is 10800 seconds (3 hours). `max-ncache-ttl` cannot exceed 7 days and will be silently truncated to 7 days if set to a greater value.
`max-cache-ttl` | `max-cache-ttl` sets the maximum time for which the server will cache ordinary (positive) answers. The default is one week (7 days).
`min-roots` | The minimum number of root servers that is required for a request for the root servers to be accepted. Default is `2` . Not yet implemented in BIND 9.
`sig-validity-interval` | Specifies the number of days into the future when DNSSEC signatures automatically generated as a result of dynamic updates (see Dynamic Update ) will expire. The default is 30 days. The signature inception time is unconditionally set to one hour before the current time to allow for a limited amount of clock skew.

##### 6.2.12.14 Deprecated Features

`use-ixfr` is deprecated in BIND 9. If you need to disable IXFR to a particular server or servers see the information on the `provide-ixfr` option in server Statement Definition and Usage . See also the description of IXFR in the section Incremental Zone Transfers (IXFR) .

#### 6.2.13 `server` Statement Grammar

    server ip_addr {

        [ bogus yes_or_no ; ]
        [ provide-ixfr yes_or_no ; ]
        [ request-ixfr yes_or_no ; ]
        [ transfers number ; ]
        [ transfer-format ( one-answer | many-answers ) ; ]
        [ keys { string ; [ string ; [...]] } ; ]
    }; }

#### 6.2.14 `server` Statement Definition and Usage

The `server` statement defines the characteristics to be associated with a remote nameserver.

If you discover that a remote server is giving out bad data, marking it as bogus will prevent further queries to it. The default value of `bogus` is `no` . The `bogus` clause is not yet implemented in BIND 9.

The `provide-ixfr` clause determines whether the local server, acting as master, will respond with an incremental zone transfer when the given remote server, a slave, requests it. If set to `yes` , incremental transfer will be provided whenever possible. If set to `no` , all transfers to the remote server will be nonincremental. If not set, the value of the `provide-ixfr` option in the global options block is used as a default.

The `request-ixfr` clause determines whether the local server, acting as a slave, will request incremental zone transfers from the given remote server, a master. If not set, the value of the `request-ixfr` option in the global options block is used as a default.

IXFR requests to servers that do not support IXFR will automatically fall back to AXFR. Therefore, there is no need to manually list which servers support IXFR and which ones do not; the global default of `yes` should always work. The purpose of the `provide-ixfr` and `request-ixfr` clauses is to make it possible to disable the use of IXFR even when both master and slave claim to support it, for example if one of the servers is buggy and crashes or corrupts data when IXFR is used.

The server supports two zone transfer methods. The first, `one-answer` , uses one DNS message per resource record transferred. `many-answers` packs as many resource records as possible into a message. `many-answers` is more efficient, but is only known to be understood by BIND 9, BIND 8.x, and patched versions of BIND 4.9.5. You can specify which method to use for a server with the `transfer-format` option. If `transfer-format` is not specified, the `transfer-format` specified by the `options` statement will be used.

`transfers` is used to limit the number of concurrent inbound zone transfers from the specified server. If no `transfers` clause is specified, the limit is set according to the `transfers-per-ns` option.

The `keys` clause is used to identify a `key_id` defined by the `key` statement, to be used for transaction security when talking to the remote server. The `key` statement must come before the `server` statement that references it. When a request is sent to the remote server, a request signature will be generated using the key specified here and appended to the message. A request originating from the remote server is not required to be signed by this key.

Although the grammar of the `keys` clause allows for multiple keys, only a single key per server is currently supported.

#### 6.2.15 `trusted-keys` Statement Grammar

    trusted-keys {
        string number number number string ;
        [ string number number number string ; [...]]
    }; }

#### 6.2.16 `trusted-keys` Statement Definition and Usage

The `trusted-keys` statement defines DNSSEC security roots. See DNSSEC for a description. A security root is defined when the public key for a non-authoritative zone is known, but cannot be securely obtained through DNS, either because it is the DNS root zone or its parent zone is unsigned. Once a key has been configured as a trusted key, it is treated as if it had been validated and proven secure. The resolver attempts DNSSEC validation on all DNS data in subdomains of a security root.

The `trusted-keys` statement can contain multiple key entries, each consisting of the key's domain name, flags, protocol, algorithm, and the base-64 representation of the key data.

#### 6.2.17 `view` Statement Grammar

     view view name {
          match-clients { address_match_list } ;
          [view_option; ...]
          [zone_statement; ...]]
    };

#### 6.2.18 `view` Statement Definition and Usage

The `view` statement is a powerful new feature of BIND 9 that lets a name server answer a DNS query differently depending on who is asking. It is particularly useful for implementing split DNS setups without having to run multiple servers.

Each `view` statement defines a view of the DNS namespace that will be seen by those clients whose IP addresses match the address_match_list of the view's `match-clients` clause. The order of the `view` statements is significant--a client query will be resolved in the context of the first `view` whose `match-clients` list matches the client's IP address.

Zones defined within a `view` statement will be only be accessible to clients that match the `view` . By defining a zone of the same name in multiple views, different zone data can be given to different clients, for example, "internal" and "external" clients in a split DNS setup.

Many of the options given in the `options` statement can also be used within a `view` statement, and then apply only when resolving queries with that view. When no a view-specific value is given, the value in the `options` statement is used as a default. Also, zone options can have default values specified in the `view` statement; these view-specific defaults take precedence over those in the `options` statement.

Views are class specific. If no class is given, class IN is assumed.

If there are no `view` statements in the config file, a default view that matches any client is automatically created in class IN, and any `zone` statements specified on the top level of the configuration file are considered to be part of this default view. If any explicit `view` statements are present, all `zone` statements must occur inside `view` statements.

Here is an example of a typical split DNS setup implemented using `view` statements.

    view "internal" {
                   // This should match our internal networks.
          match-clients { 10.0.0.0/8; };
                   // Provide recursive service to internal clients only.
          recursion yes;
                   // Provide a complete view of the example.com zone
                   // including addresses of internal hosts.
          zone "example.com" {
                type master;
                file "example-internal.db";
          };
      };

      view "external" {
          match-clients { any; };
                   // Refuse recursive service to external clients.
          recursion no;
                   // Provide a restricted view of the example.com zone
                   // containing only publicly accessible hosts.
          zone "example.com" {
               type master;
               file "example-external.db";
          };
      };

#### 6.2.19 `zone` Statement Grammar

    zone zone name [class] [{
        type ( master|slave|hint|stub|forward ) ;
        [ allow-query { address_match_list } ; ]
        [ allow-transfer { address_match_list } ; ]
        [ allow-update { address_match_list } ; ]
        [ update-policy { update_policy_rule[...] } ; ]
        [ allow-update-forwarding { address_match_list } ; ]
        [ also-notify { [ ip_addr ; [ip_addr ; [...]]] } ; ]
        [ check-names (warn|fail|ignore) ; ]
        [ dialup true_or_false ; ]
        [ file string ; ]
        [ forward (only|first) ; ]
        [ forwarders { [ ip_addr ; [ ip_addr ; [...]]] } ; ]
        [ ixfr-base string ; ]
        [ ixfr-tmp-file string ; ]
        [ maintain-ixfr-base true_or_false ; ]
        [ masters [port number] { ip_addr ; [ip_addr ; [...]] } ; ]
        [ max-ixfr-log-size number ; ]
        [ max-transfer-idle-in number ; ]
        [ max-transfer-idle-out number ; ]
        [ max-transfer-time-in number ; ]
        [ max-transfer-time-out number ; ]
        [ notify true_or_false ; ]
        [ pubkey number number number string ;  ]
        [ transfer-source (ip4_addr | *) ;  ]
        [ transfer-source-v6 (ip6_addr | *) ;  ]
        [ sig-validity-interval number ; ]
    } ];

#### 6.2.20 `zone` Statement Definition and Usage

##### 6.2.20.1 Zone Types

master | The server has a master copy of the data for the zone and will be able to provide authoritative answers for it.
slave | A slave zone is a replica of a master zone. The masters list specifies one or more IP addresses that the slave contacts to update its copy of the zone. If a port is specified, the slave then checks to see if the zone is current and zone transfers will be done to the port given. If a file is specified, then the replica will be written to this file whenever the zone is changed, and reloaded from this file on a server restart. Use of a file is recommended, since it often speeds server start-up and eliminates a needless waste of bandwidth. Note that for large numbers (in the tens or hundreds of thousands) of zones per server, it is best to use a two level naming scheme for zone file names. For example, a slave server for the zone example.com might place the zone contents into a file called ex/example.com where ex/ is just the first two letters of the zone name. (Most operating systems behave very slowly if you put 100K files into a single directory.)
stub | A stub zone is similar to a slave zone, except that it replicates only the NS records of a master zone instead of the entire zone. Stub zones are not a standard part of the DNS; they are a peculiarity of BIND 4 and BIND 8 that relies heavily on the particular way the zone data is structured in those servers. BIND 9 attempts to emulate the BIND 4/8 stub zone feature for backwards compatibility, but we do not recommend its use in new configurations. In BIND 4/8, zone transfers of a parent zone included the NS records from stub children of that zone. This meant that, in some cases, users could get away with configuring child stubs only in the master server for the parent zone. BIND 9 never mixes together zone data from different zones in this way. Therefore, if a BIND 9 master serving a parent zone has child stub zones configured, all the slave servers for the parent zone also need to have the same child stub zones configured..
forward | A "forward zone" is a way to configure forwarding on a per-domain basis. A `zone` statement of type `forward` can contain a `forward` and/or `forwarders` statement, which will apply to queries within the domain given by the zone name. If no `forwarders` statement is present or an empty list for `forwarders` is given, then no forwarding will be done for the domain, cancelling the effects of any forwarders in the `options` statement. Thus if you want to use this type of zone to change the behavior of the global `forward` option (that is, "forward first to", then "forward only", or vice versa, but want to use the same servers as set globally) you need to respecify the global forwarders. Domain-specific forwarding is not yet implemented in BIND 9.
hint | The initial set of root nameservers is specified using a "hint zone". When the server starts up, it uses the root hints to find a root nameserver and get the most recent list of root nameservers. If no hint zone is specified for class IN, the server users a compiled-in default set of root servers hints. Classes other than IN have no built-in defaults hints.

##### 6.2.20.2 Class

The zone's name may optionally be followed by a class. If a class is not specified, class IN (for Internet ), is assumed. This is correct for the vast majority of cases.

The hesiod class is named for an information service from MIT's Project Athena. It is used to share information about various systems databases, such as users, groups, printers and so on. The keyword HS is a synonym for hesiod.

Another MIT development is CHAOSnet, a LAN protocol created in the mid-1970s. Zone data for it can be specified with the CHAOS class.

##### 6.2.20.3 Zone Options

`allow-query` | See the description of `allow-query` under Access Control .
`allow-transfer` | See the description of `allow-transfer` under Access Control .
`allow-update` | Specifies which hosts are allowed to submit Dynamic DNS updates for master zones. The default is to deny updates from all hosts.
`update-policy` | Specifies a "Simple Secure Update" policy. See description in Dynamic Update Policies .
`allow-update-forwarding` | Specifies which hosts are allowed to submit Dynamic DNS updates to slave zones to be forwarded to the master. The default is to deny update forwarding from all hosts. Update forwarding is not yet implemented.
`also-notify` | Only meaningful if `notify` is active for this zone. The set of machines that will receive a DNS NOTIFY message for this zone is made up of all the listed nameservers (other than the primary master) for the zone plus any IP addresses specified with `also-notify` . `also-notify` is not meaningful for stub zones. The default is the empty list .
`check-names` | See Name Checking . Not yet implemented in BIND 9.
`dialup` | See the description of `dialup` under Boolean Options . Not yet implemented in BIND 9.
`forward` | Only meaningful if the zone has a forwarders list. The `only` value causes the lookup to fail after trying the forwarders and getting no answer, while `first` would allow a normal lookup to be tried. Not yet implemented in BIND 9.
`forwarders` | Used to override the list of global forwarders. If it is not specified in a zone of type `forward` , no forwarding is done for the zone; the global options are not used. Not yet implemented in BIND 9.
`ixfr-base` | Was used in BIND 8 to specify the name of the transaction log (journal) file for dynamic update and IXFR. BIND 9 ignores the option and constructs the name of the journal file by appending ". jnl " to the name of the zone file.
`max-transfer-time-in` | See the description of `max-transfer-time-in` under Zone Transfers .
`max-transfer-idle-in` | See the description of `max-transfer-idle-in` under Zone Transfers .
`max-transfer-time-out` | See the description of `max-transfer-time-out` under Zone Transfers .
`max-transfer-idle-out` | See the description of `max-transfer-idle-out` under Zone Transfers .
`notify` | See the description of `notify` under Boolean Options .
`pubkey` | In BIND 8, this option was intended for specifying a public zone key for verification of signatures in DNSSEC signed zones when they are loaded from disk. BIND 9 does not verify signatures on loading and ignores the option.
`sig-validity-interval` | See the description of `sig-validity-interval` in Tuning .
`transfer-source` | Determines which local address will be bound to the IPv4 TCP connection used to fetch this zone. If not set, it defaults to a system controlled value which will usually be the address of the interface "closest to" the remote end. If the remote end user is an `allow-transfer` option for this zone, the address, supplied by the `transfer-source` option, needs to be specified in that `allow-transfer` option.
transfer-source-v6 | Similar to transfer-source, but for zone transfers performed using IPv6.

##### 6.2.20.4 Dynamic Update Policies

BIND 9 supports two alternative methods of granting clients the right to perform dynamic updates to a zone, configured by the `allow-update` and `update-policy` option, respectively.

The `allow-update` clause works the same way as in previous versions of BIND. It grants given clients the permission to update any record of any name in the zone.

The `update-policy` clause is new in BIND 9 and allows more fine-grained control over what updates are allowed. A set of rules is specified, where each rule either grants or denies permissions for one or more names to be updated by one or more identities. If the dynamic update request message is signed (that is, it includes either a TSIG or SIG(0) record), the identity of the signer can be determined.

Rules are specified in the `update-policy` zone option, and are only meaningful for master zones. When the `update-policy` statement is present, it is a configuration error for the `allow-update` statement to be present. The `update-policy` statement only examines the signer of a message; the source address is not relevant.

This is how a rule definition looks:

    ( grant | deny ) identity nametype name [ types ]

Each rule grants or denies privileges. Once a messages has successfully matched a rule, the operation is immediately granted or denied and no further rules are examined. A rule is matched when the signer matches the identity field, the name matches the name field, and the type is specified in the type field.

The identity field specifies a name or a wildcard name. The nametype field has 4 values: name , subdomain , wildcard , and self .

###### name | Matches when the updated name is the same as the name in the name field.
###### subdomain | Matches when the updated name is a subdomain of the name in the name field.
###### wildcard | Matches when the updated name is a valid expansion of the wildcard name in the name field.
###### self | Matches when the updated name is the same as the message signer. The name field is ignored.

If no types are specified, the rule matches all types except SIG, NS, SOA, and NXT. Types may be specified by name, including "ANY" (ANY matches all types except NXT, which can never be updated).

### 6.3 Zone File

#### 6.3.1 Types of Resource Records and When to Use Them

This section, largely borrowed from RFC 1034, describes the concept of a Resource Record (RR) and explains when each is used. Since the publication of RFC 1034, several new RRs have been identified and implemented in the DNS. These are also included.

##### 6.3.1.1 Resource Records

A domain name identifies a node. Each node has a set of resource information, which may be empty. The set of resource information associated with a particular name is composed of separate RRs. The order of RRs in a set is not significant and need not be preserved by nameservers, resolvers, or other parts of the DNS. However, sorting of multiple RRs is permitted for optimization purposes, for example, to specify that a particular nearby server be tried first. See The sortlist Statement and RRset Ordering for details.

The components of a Resource Record are

owner name | the domain name where the RR is found.
type | an encoded 16 bit value that specifies the type of the resource in this resource record. Types refer to abstract resources.
TTL | the time to live of the RR. This field is a 32 bit integer in units of seconds, and is primarily used by resolvers when they cache RRs. The TTL describes how long a RR can be cached before it should be discarded.
class | an encoded 16 bit value that identifies a protocol family or instance of a protocol.
RDATA | the type and sometimes class-dependent data that describes the resource.

The following are types of valid RRs (some of these listed, although not obsolete, are experimental (x) or historical (h) and no longer in general use):

A | a host address.
A6 | an IPv6 address.
AAAA | Obsolete format of IPv6 address
AFSDB | (x) location of AFS database servers. Experimental.
CNAME | identifies the canonical name of an alias.
DNAME | for delegation of reverse addresses. Replaces the domain name specified with another name to be looked up. Described in RFC 2672.
HINFO | identifies the CPU and OS used by a host.
ISDN | (x) representation of ISDN addresses. Experimental.
KEY | stores a public key associated with a DNS name.
LOC | (x) for storing GPS info. See RFC 1876. Experimental.
MX | identifies a mail exchange for the domain. See RFC 974 for details.
NS | the authoritative nameserver for the domain.
NXT | used in DNSSEC to securely indicate that RRs with an owner name in a certain name interval do not exist in a zone and indicate what RR types are present for an existing name. See RFC 2535 for details.
PTR | a pointer to another part of the domain name space.
RP | (x) information on persons responsible for the domain. Experimental.
RT | (x) route-through binding for hosts that do not have their own direct wide area network addresses. Experimental.
SIG | ("signature") contains data authenticated in the secure DNS. See RFC 2535 for details.
SOA | identifies the start of a zone of authority.
SRV | information about well known network services (replaces WKS).
WKS | (h) information about which well known network services, such as SMTP, that a domain supports. Historical, replaced by newer RR SRV.
X25 | (x) representation of X.25 network addresses. Experimental.

The following classes of resource records are currently valid in the DNS:

IN | the Internet system.
For information about other, older classes of RRs, see Classes of Resource Records in the Appendix.

RDATA is the type-dependent or class-dependent data that describes the resource:

A | for the IN class, a 32 bit IP address.
A6 | maps a domain name to an IPv6 address, with a provision for indirection for leading "prefix" bits.
CNAME | a domain name.
DNAME | provides alternate naming to an entire subtree of the domain name space, rather than to a single node. It causes some suffix of a queried name to be substituted with a name from the DNAME record's RDATA.
MX | a 16 bit preference value (lower is better) followed by a host name willing to act as a mail exchange for the owner domain.
NS | a fully qualified domain name.
PTR | a fully qualified domain name.
SOA | several fields.

The owner name is often implicit, rather than forming an integral part of the RR. For example, many nameservers internally form tree or hash structures for the name space, and chain RRs off nodes. The remaining RR parts are the fixed header (type, class, TTL) which is consistent for all RRs, and a variable part (RDATA) that fits the needs of the resource being described.

The meaning of the TTL field is a time limit on how long an RR can be kept in a cache. This limit does not apply to authoritative data in zones; it is also timed out, but by the refreshing policies for the zone. The TTL is assigned by the administrator for the zone where the data originates. While short TTLs can be used to minimize caching, and a zero TTL prohibits caching, the realities of Internet performance suggest that these times should be on the order of days for the typical host. If a change can be anticipated, the TTL can be reduced prior to the change to minimize inconsistency during the change, and then increased back to its former value following the change.

The data in the RDATA section of RRs is carried as a combination of binary strings and domain names. The domain names are frequently used as "pointers" to other data in the DNS.

##### 6.3.1.2 Textual expression of RRs

RRs are represented in binary form in the packets of the DNS protocol, and are usually represented in highly encoded form when stored in a nameserver or resolver. In the examples provided in RFC 1034, a style similar to that used in master files was employed in order to show the contents of RRs. In this format, most RRs are shown on a single line, although continuation lines are possible using parentheses.

The start of the line gives the owner of the RR. If a line begins with a blank, then the owner is assumed to be the same as that of the previous RR. Blank lines are often included for readability.

Following the owner, we list the TTL, type, and class of the RR. Class and type use the mnemonics defined above, and TTL is an integer before the type field. In order to avoid ambiguity in parsing, type and class mnemonics are disjoint, TTLs are integers, and the type mnemonic is always last. The IN class and TTL values are often omitted from examples in the interests of clarity.

The resource data or RDATA section of the RR are given using knowledge of the typical representation for the data.

For example, we might show the RRs carried in a message as:

ISI.EDU. | MX | 10 VENERA.ISI.EDU.
| MX | 10 VAXA.ISI.EDU
VENERA.ISI.EDU | A | 128.9.0.32
| A | 10.1.0.52
VAXA.ISI.EDU | A | 10.2.0.27
| A | 128.9.0.33

The MX RRs have an RDATA section which consists of a 16 bit number followed by a domain name. The address RRs use a standard IP address format to contain a 32 bit internet address.

This example shows six RRs, with two RRs at each of three domain names.

Similarly we might see:

XX.LCS.MIT.EDU. IN | A | 10.0.0.44
CH | A | MIT.EDU. 2420

This example shows two addresses for XX.LCS.MIT.EDU , each of a different class.

#### 6.3.2 Discussion of MX Records

As described above, domain servers store information as a series of resource records, each of which contains a particular piece of information about a given domain name (which is usually, but not always, a host). The simplest way to think of a RR is as a typed pair of datum, a domain name matched with relevant data, and stored with some additional type information to help systems determine when the RR is relevant.

MX records are used to control delivery of email. The data specified in the record is a priority and a domain name. The priority controls the order in which email delivery is attempted, with the lowest number first. If two priorities are the same, a server is chosen randomly. If no servers at a given priority are responding, the mail transport agent will fall back to the next largest priority. Priority numbers do not have any absolute meaning - they are relevant only respective to other MX records for that domain name. The domain name given is the machine to which the mail will be delivered. It must have an associated A record--a CNAME is not sufficient.

For a given domain, if there is both a CNAME record and an MX record, the MX record is in error, and will be ignored. Instead, the mail will be delivered to the server specified in the MX record pointed to by the CNAME.

For example:

example.com. | IN | MX | 10 | mail.example.com.
| IN | MX | 10 | mail2.example.com.
| IN | MX | 20 | mail.backup.org.
mail.example.com. | IN | A | 10.0.0.1 |
mail2.example.com. | IN | A | 10.0.0.2 |

Mail delivery will be attempted to mail.example.com and mail2.example.com (in any order), and if neither of those succeed, delivery to mail.backup.org will be attempted.

#### 6.3.3 Setting TTLs

The time to live of the RR field is a 32 bit integer represented in units of seconds, and is primarily used by resolvers when they cache RRs. The TTL describes how long a RR can be cached before it should be discarded. The following three types of TTL are currently used in a zone file.

SOA | The last field in the SOA is the negative caching TTL. This controls how long other servers will cache no-such-domain (NXDOMAIN) responses from you. The maximum time for negative caching is 3 hours (3h).
$TTL | The $TTL directive at the top of the zone file (before the SOA) gives a default TTL for every RR without a specific TTL set.
RR TTLs | Each RR can have a TTL as the second field in the RR, which will control how long other servers can cache the it.

All of these TTLs default to units of seconds, though units can be explicitly specified, for example, 1h30m .

#### 6.3.4 Inverse Mapping in IPv4

Reverse name resolution (that is, translation from IP address to name) is achieved by means of the in-addr.arpa domain and PTR records. Entries in the in-addr.arpa domain are made in least-to-most significant order, read left to right. This is the opposite order to the way IP addresses are usually written. Thus, a machine with an IP address of 10.1.2.3 would have a corresponding in-addr.arpa name of
3.2.1.10.in-addr.arpa. This name should have a PTR resource record whose data field is the name of the machine or, optionally, multiple PTR records if the machine has more than one name. For example, in the example.com domain:

    $ORIGIN			2.1.10.in-addr.arpa
    3			IN PTR foo.example.com.

(Note: The `$ORIGIN` lines in the examples are for providing context to the examples only--they do not necessarily appear in the actual usage. They are only used here to indicate that the example is relative to the listed origin.)

#### 6.3.5 Other Zone File Directives

The Master File Format was initially defined in RFC 1035 and has subsequently been extended. While the Master File Format itself is class independent all records in a Master File must be of the same class.

Master File Directives include `$ORIGIN` , `$INCLUDE` , and `$TTL.`

##### 6.3.5.1 The `$ORIGIN` Directive

Syntax: `$ORIGIN <` domain-name `>` [ `<` comment `>` ]

`$ORIGIN` sets the domain name that will be appended to any unqualified records. When a zone is first read in there is an implicit `$ORIGIN` < zone-name >`.` The current `$ORIGIN` is appended to the domain specified in the `$ORIGIN` argument if it is not absolute.

    $ORIGIN example.com
    WWW     CNAME   MAIN-SERVER

is equivalent to

    WWW.EXAMPLE.COM CNAME MAIN-SERVER.EXAMPLE.COM.

##### 6.3.5.2 The `$INCLUDE` Directive

Syntax: `$INCLUDE <` filename `>` [ `<` origin `>` ] [ `<` comment `>` ]

Read and process the file filename as if it were included into the file at this point. If `origin` is specified the file is processed with `$ORIGIN` set to that value, otherwise the current `$ORIGIN` is used.

NOTE: The behavior when `origin` is specified differs from that described in RFC 1035. The origin and current domain revert to the values they were prior to the `$INCLUDE` once the file has been read.

##### 6.3.5.3 The `$TTL` Directive

Syntax: `$TTL <` default-ttl `>` [ `<` comment `>` ]

Set the default Time To Live (TTL) for subsequent records with undefined TTLs. Valid TTLs are of the range 0-2147483647 seconds.

`$TTL` is defined in RFC 2308.

#### 6.3.6 BIND Master File Extension: the `$GENERATE` Directive

    $GENERATE

Syntax: `$GENERATE <` range `> <` lhs `> <` type `> <` rhs `>` [ `<` comment `>` ]

`$GENERATE` is used to create a series of resource records that only differ from each other by an iterator. `$GENERATE` can be used to easily generate the sets of records required to support sub /24 reverse delegations described in RFC 2317: Classless IN-ADDR.ARPA delegation.

    $ORIGIN 0.0.192.IN-ADDR.ARPA.
    $GENERATE 1-2 0 NS SERVER$.EXAMPLE.
    $GENERATE 1-127 $ CNAME $.0

is equivalent to

    0.0.0.192.IN-ADDR.ARPA NS SERVER1.EXAMPLE.
    0.0.0.192.IN-ADDR.ARPA NS SERVER2.EXAMPLE.
    1.0.0.192.IN-ADDR.ARPA CNAME 1.0.0.0.192.IN-ADDR.ARPA
    2.0.0.192.IN-ADDR.ARPA CNAME 2.0.0.0.192.IN-ADDR.ARPA
    ...
    127.0.0.192.IN-ADDR.ARPA CNAME 127.0.0.0.192.IN-ADDR.ARPA
    .

``

`range` | This can be one of two forms: start-stop or start-stop/step. If the first form is used then step is set to 1. All of start, stop and step must be positive.
`lhs` | `lhs` describes the owner name of the resource records to be created. Any single `$` symbols within the `lhs` side are replaced by the iterator value. To get a $ in the output use a double `$` , e.g. `$$` . If the `lhs` is not absolute, the current `$ORIGIN` is appended to the name.
`type` | At present the only supported types are PTR, CNAME and NS.
`rhs` | rhs is a domain name. It is processed similarly to lhs.

The `$GENERATE` directive is a BIND extension and not part of the standard zone file format. It is not yet implemented in BIND 9.

Return to BIND 9 Administrator Reference Manual table of contents.